(	--a pair of brackets define a LOCAL scope. Local is good.
	--these below are now LOCALLY declared, and available throughout the script, but ONLY within the script.
	
	timeSliderWasVisible=undefined
	trackBarWasVisible=undefined
	statusPanelWasVisible=undefined
	expertModeWasActive=undefined
	matEditorWasOpen=undefined		
	
	fn resetUIStatusVariables = --in case one needs to reset the variables' statuses
	(
		timeSliderWasVisible=undefined
		trackBarWasVisible=undefined
		statusPanelWasVisible=undefined
		expertModeWasActive=undefined
		matEditorWasOpen=undefined		
	)
	
	fn getUIStatus =	--queries the various UI elements' statuses, and stores it into the local variables
	(
		timeSliderWasVisible=timeslider.isVisible()
		trackBarWasVisible=trackbar.visible
		statusPanelWasVisible=statusPanel.visible
		expertModeWasActive=cui.getExpertMode() 
		matEditorWasOpen = MatEditor.isOpen()
	)	
	
	fn resetSEMode = --this resets the max UI to default status. Useful in case a script breaks while the UI is in the "super expert mode" state
	(
		timeslider.Setvisible true	
		trackbar.visible = true
		cui.expertModeOff()
		statusPanel.visible = true
		enableSceneRedraw()
		resumeEditing()
	)
	
	fn setSuperExpertMode status = --the core function which sets the status of the UI to "super expert mode" 
	(
		if status then 		--if the bool is true/1/on then 
		( 
			getUIStatus()	--we gather the UI status right before  changing it
			
			timeslider.Setvisible false		--turn off the time slider
			trackbar.visible = false		--turn off the track bar
			cui.expertModeOn()				-- set the UI in expert mode
			statusPanel.visible = false		--hide the status bar as well (consider NOT doing this if showing a progressbar in the status panel at the bottom.)
			MatEditor.close()		--close the material editor (not slate!)
			disableSceneRedraw() 	--won't update viewports		
			suspendEditing() --this is like moving to the creation panel, in that it doesn't update the UI, regardless of what's active in the UI. new from max 7, i think. First time i use it! :P
		)
		
		else 				--if the bool is false/0/off, then 
		(
			--we return the UI to its original state, if those states were correctly gathered, otherwise we default to the standard UI visibility setup
			if timeSliderWasVisible != undefined then 
			(
				timeslider.Setvisible timeSliderWasVisible
			)
			else 
			(
				timeslider.Setvisible true	
			)
			
			if trackBarWasVisible != undefined then 
			(
				trackbar.visible = trackBarWasVisible 
			)
			else 
			(
				trackbar.visible = true
			)
			
			if expertModeWasActive != undefined then	
			(
				if not expertModeWasActive do cui.expertModeOff()
			)
			else 
			(
				cui.expertModeOff()
			)
			
			if statusPanelWasVisible != undefined then 
			(
				statusPanel.visible = statusPanelWasVisible 
			)
			else 
			(
				statusPanel.visible = true
			)
			
			if matEditorWasOpen != undefined do 
			(
				if matEditorWasOpen do matEditor.open()
			)
			enableSceneRedraw()
			resumeEditing()
		)
	)
	
	--there is one more thing to be done for long processing, and it's done within the main function loop itself.
	
	fn myMainFunction =
	(
		setSuperExpertMode true --turns on "super expert mode"
		actionMan.executeAction 0 "40472" --open the Listener to see the printout
		clearListener() --self explicative
		for i = 1 to 1000 do --your long loop
		(
			windows.processPostedMessages() --this forces windows to update the max UI, the listener and in case the script UI as often as needed. It prevents the UI locking up and prompting windows to close the application.
			try 	--error trapping. If you know of better methods, use those.
				(
					print ((sqrt(i as float *i*log (Pi))/log10 (i as float *i*i)) as string) --your costly process
				)
			catch 
				(
					resetSEMode() --we failed, so the UI gets RESET to factory defaults, regardless of its original state. Alternatively, you could still try to use "setSuperExpertMode false", the result would then respect the previous UI setup.
					exit with (messageBox "We've got an error!")
				)
		)
		setSuperExpertMode false --turns off "super expert mode"
	)
	
	myMainFunction()
	
)